; Z80 Interpreter.
; This is part of the Z80-CP/M emulator written by Sprite_tm.

;    Copyright (C) 2010 Sprite_tm, Leo C.

;    This file is part of avrcpm.
;
;    avrcpm is free software: you can redistribute it and/or modify it
;    under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    avrcpm is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with avrcpm.  If not, see <http://www.gnu.org/licenses/>.
;
;    $Id$
;

	.dseg
	
; Don't change order
	
z_b:	.byte	1
z_c:	.byte	1
z_d:	.byte	1
z_e:	.byte	1
z_h:	.byte	1
z_l:	.byte	1

; Alternate register set

Z80_b:	.byte	1
Z80_c:	.byte	1
Z80_d:	.byte	1
Z80_e:	.byte	1
Z80_h:	.byte	1
Z80_l:	.byte	1
Z80_f:	.byte	1
Z80_a:	.byte	1

.equ	OFS_ALT = z80_b - z_b

	.cseg
	
printregs:
	rcall	printstr
	.db	13,"        A =",0,0
	mov	temp,z_a
	rcall	printhex	
	rcall	printstr
	.db	" BC =",0
	lds	temp2,z_b
	lds	temp, z_c
	rcall	printhexw
	rcall	printstr
	.db	" DE =",0
	lds	temp2,z_d
	lds	temp, z_e
	rcall	printhexw
	rcall	printstr
	.db	" HL =",0
	lds	temp2,z_h
	lds	temp, z_l
	rcall	printhexw
	rcall	printstr
	.db	" SP =",0
	movw	temp, z_spl
	rcall	printhexw
	rcall	printstr
	.db	" PC =",0
	movw	temp, z_pcl
	rcall	printhexw
	rcall	printstr
	.db	"       ",0
	movw 	xl,z_pcl
	mem_read				;temp=memReadByte(adr)
	rcall	printhex
	rcall	printstr
	.db	"  ",0,0
	ret

;Init z80
z80_init:
	ldi z_pcl,low (IPLADDR)
	ldi z_pch,high(IPLADDR)

	cbi	flags,trace
	rcall printstr
	.db 13,"Ok, CPU is live!",13,0,0

;----------------------------------------------------------
;		1				2			3			4
;.db 	(low)do_store	(low)do_op  (hihg)do_op	(low)do_fetch
;
;das kommt auf den stapel
;  	main				da solls zum schluss weitergehen
;	do_store			wohin damit		beenden mit RET
;	do_op				was tun			beenden mit RET
;
;das wird direkt angesprungen
;	do_fetch			woher			beenden mit RET
;
;	
main:
.if INS_DEBUG
	cbi	flags,trace
;	cpi z_pch,1
;	brlo notraceon
;	cpi z_pch,$dc
;	brsh notraceon
	sbi	flags,trace
notraceon:
.endif


.if PRINT_PC
;	cpi z_pch,1
;	brlo noprintpc
;	cpi z_pch,0xdc
;	brsh noprintpc

	rcall printstr
	.db 13,"PC=",0
	movw temp,z_pcl
	rcall printhexw
	ldi temp,' '
;	ldi temp,10
;	rcall uartputc
noprintpc:
.endif

.if INS_DEBUG
	sbic	flags,trace
	 rcall	printregs
.endif

	;hier kommt die Interruptbehandlung rein
	
	ldi 	zl,low(main)			;da will ich wieder hin.
	ldi 	zh,high(main)			;
	push	zl						;
	push	zh						;
	movw 	xl,z_pcl				;
	mem_read						;temp=memReadByte(z_pc)
	adiw	z_pcl,1					;++z_pc
	ldi		zl,low(todo_table*2)	;zhl=todo_table
	ldi		zh,high(todo_table*2)	;
	ldi		temp2,4					;1
	mul		temp,temp2				;2
	add		zl,_tmp					;1
	adc		zh,_0					;1
	clr		_0						; <--- den verstehe ich inner noch nicht?
	ldi		temp2,high(do_nop)		; 
	lpm		temp,Z+					;do_store 
	push	temp					;         low
	push	temp2					;         high
	lpm		temp,Z+					;do_op    
	push	temp					;         low
	lpm		temp,Z+					;         high
	push	temp					;
	lpm		temp,Z					;do_fetch
	lpm		zl,Z					;
	mov		zh,temp2				;
	ijmp							;direkt




; ------------ Fetch phase stuff -----------------
.org (PC+255) & 0xff00			; wichtig !!!fetch und store muessen in einer page liegen

do_nop:							; do_nop muss als erstes kommen
	ret

do_fetch_a:
	mov opl,z_a
	ret

do_fetch_b:
	lds opl,z_b
	ret

do_fetch_c:
	lds opl,z_c
	ret

do_fetch_d:
	lds opl,z_d
	ret

do_fetch_e:
	lds opl,z_e
	ret

do_fetch_h:
	lds opl,z_h
	ret

do_fetch_l:
	lds opl,z_l
	ret

do_fetch_af:
	mov opl,z_flags
	mov oph,z_a
	ret

do_fetch_bc:
	lds opl,z_c
	lds oph,z_b
	ret

do_fetch_de:
	lds opl,z_e
	lds oph,z_d
	ret

do_fetch_hl:
	lds opl,z_l
	lds oph,z_h
	ret

do_fetch_sp:
	movw opl,z_spl
	ret

do_fetch_mbc:
	lds xh,z_b
	lds xl,z_c
	mem_read_d opl
	ret

do_fetch_mde:
	lds xh,z_d
	lds xl,z_e
	mem_read_d opl
	ret

do_fetch_mhl:
	lds xh,z_h
	lds xl,z_l
	mem_read_d opl
	ret

do_fetch_msp:
	movw x,z_spl
	mem_read_d opl
	adiw x,1
	mem_read_d oph
	ret

do_fetch_dir8:
	mem_read_ds opl, z_pcl
	adiw z_pcl,1
	ret

do_fetch_dir16:
	mem_read_ds opl, z_pcl
	adiw z_pcl,1
	mem_read_ds oph, z_pcl
	adiw z_pcl,1
	ret

do_fetch_rst:
	movw x,z_pcl
	sbiw x,1
	mem_read_d opl
	andi opl,0x38
	ldi oph,0
	ret

; ------------ Store phase stuff -----------------

do_store_a:
	mov z_a,opl
	ret

do_store_b:
	sts z_b,opl
	ret

do_store_c:
	sts z_c,opl
	ret

do_store_d:
	sts z_d,opl
	ret

do_store_e:
	sts z_e,opl
	ret

do_store_h:
	sts z_h,opl
	ret

do_store_l:
	sts z_l,opl
	ret

do_store_af:
	mov z_a,oph
	mov z_flags,opl
	ret

do_store_bc:
	sts z_b,oph
	sts z_c,opl
	ret

do_store_de:
	sts z_d,oph
	sts z_e,opl
	ret

do_store_hl:
	sts z_h,oph
	sts z_l,opl
	ret

do_store_mbc:
	lds xh,z_b
	lds xl,z_c
	mem_write_s opl
	ret

do_store_mde:
	lds xh,z_d
	lds xl,z_e
	mem_write_s opl
	ret

do_store_mhl:
	lds xh,z_h
	lds xl,z_l
	mem_write_s opl
	ret

do_store_msp:
	movw xl,z_spl
	mem_write_s opl
	adiw xl,1
	mem_write_s oph
	ret

do_store_sp:
	movw z_spl,opl
	ret

do_store_pc:
	movw z_pcl,opl
	ret

do_store_ret:
	rcall do_op_pop16
	movw z_pcl,opl
	ret

do_store_call:
	push opl
	push oph
	movw opl,z_pcl
	rcall do_op_push16
	pop z_pch
	pop z_pcl
	ret

do_store_am:
	mem_write_ds opl, z_a
	ret

; ------------ Operation phase stuff -----------------

;How the flags are supposed to work:
;7 ZFL_S - Sign flag (=MSBit of result)
;6 ZFL_Z - Zero flag. Is 1 when the result is 0
;4 ZFL_H - Half-carry (carry from bit 3 to 4)
;2 ZFL_P - Parity/2-complement Overflow
;1 ZFL_N - Subtract - set if last op was a subtract
;0 ZFL_C - Carry
;
;I sure hope I got the mapping between flags and instructions correct...

;----------------------------------------------------------------
;|                                                              |
;|                            Zilog                             |
;|                                                              |
;|                 ZZZZZZZ    88888      000                    |
;|                      Z    8     8    0   0                   |
;|                     Z     8     8   0   0 0                  |
;|                    Z       88888    0  0  0                  |
;|                   Z       8     8   0 0   0                  |
;|                  Z        8     8    0   0                   |
;|                 ZZZZZZZ    88888      000                    |
;|                                                              |
;|          Z80 MICROPROCESSOR Instruction Set Summary          |
;|                                                              |
;----------------------------------------------------------------
;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;|----------+------+---------------------+----------------------|
;|ADC A,s   |***V0*|Add with Carry       |A=A+s+CY              |
;|ADC HL,ss |**?V0*|Add with Carry       |HL=HL+ss+CY           |
;|ADD A,s   |***V0*|Add                  |A=A+s                 |
;|ADD HL,ss |--?-0*|Add                  |HL=HL+ss              |
;|ADD IX,pp |--?-0*|Add                  |IX=IX+pp              |
;|ADD IY,rr |--?-0*|Add                  |IY=IY+rr              |
;|AND s     |**1P00|Logical AND          |A=A&s                 |
;|BIT b,m   |?*1?0-|Test Bit             |m&{2^b}               |
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|CALL nn   |------|Unconditional Call   |-[SP]=PC,PC=nn        |
;|CCF       |--?-0*|Complement Carry Flag|CY=~CY                |
;|CP s      |***V1*|Compare              |A-s                   |
;|CPD       |****1-|Compare and Decrement|A-[HL],HL=HL-1,BC=BC-1|
;|CPDR      |****1-|Compare, Dec., Repeat|CPD till A=[HL]or BC=0|
;|CPI       |****1-|Compare and Increment|A-[HL],HL=HL+1,BC=BC-1|
;|CPIR      |****1-|Compare, Inc., Repeat|CPI till A=[HL]or BC=0|
;|CPL       |--1-1-|Complement           |A=~A                  |
;|DAA       |***P-*|Decimal Adjust Acc.  |A=BCD format          |
;|DEC s     |***V1-|Decrement            |s=s-1                 |
;|DEC xx    |------|Decrement            |xx=xx-1               |
;|DEC ss    |------|Decrement            |ss=ss-1               |
;|DI        |------|Disable Interrupts   |                      |
;|DJNZ e    |------|Dec., Jump Non-Zero  |B=B-1 till B=0        |
;|EI        |------|Enable Interrupts    |                      |
;|EX [SP],HL|------|Exchange             |[SP]<->HL             |
;|EX [SP],xx|------|Exchange             |[SP]<->xx             |
;|EX AF,AF' |------|Exchange             |AF<->AF'              |
;|EX DE,HL  |------|Exchange             |DE<->HL               |
;|EXX       |------|Exchange             |qq<->qq'   (except AF)|
;|HALT      |------|Halt                 |                      |
;|IM n      |------|Interrupt Mode       |             (n=0,1,2)|
;|IN A,[n]  |------|Input                |A=[n]                 |
;|IN r,[C]  |***P0-|Input                |r=[C]                 |
;|INC r     |***V0-|Increment            |r=r+1                 |
;|INC [HL]  |***V0-|Increment            |[HL]=[HL]+1           |
;|INC xx    |------|Increment            |xx=xx+1               |
;|INC [xx+d]|***V0-|Increment            |[xx+d]=[xx+d]+1       |
;|INC ss    |------|Increment            |ss=ss+1               |
;|IND       |?*??1-|Input and Decrement  |[HL]=[C],HL=HL-1,B=B-1|
;|INDR      |?1??1-|Input, Dec., Repeat  |IND till B=0          |
;|INI       |?*??1-|Input and Increment  |[HL]=[C],HL=HL+1,B=B-1|
;|INIR      |?1??1-|Input, Inc., Repeat  |INI till B=0          |
;|JP [HL]   |------|Unconditional Jump   |PC=[HL]               |
;|JP [xx]   |------|Unconditional Jump   |PC=[xx]               |
;|JP nn     |------|Unconditional Jump   |PC=nn                 |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|JR e      |------|Unconditional Jump   |PC=PC+e               |
;|JR cc,e   |------|Conditional Jump     |If cc JR(cc=C,NC,NZ,Z)|
;|LD dst,src|------|Load                 |dst=src               |
;|LD A,i    |**0*0-|Load                 |A=i            (i=I,R)|
;|LDD       |--0*0-|Load and Decrement   |[DE]=[HL],HL=HL-1,#   |
;|LDDR      |--000-|Load, Dec., Repeat   |LDD till BC=0         |
;|LDI       |--0*0-|Load and Increment   |[DE]=[HL],HL=HL+1,#   |
;|LDIR      |--000-|Load, Inc., Repeat   |LDI till BC=0         |
;|NEG       |***V1*|Negate               |A=-A                  |
;|NOP       |------|No Operation         |                      |
;|OR s      |**0P00|Logical inclusive OR |A=Avs                 |
;|OTDR      |?1??1-|Output, Dec., Repeat |OUTD till B=0         |
;|OTIR      |?1??1-|Output, Inc., Repeat |OUTI till B=0         |
;|OUT [C],r |------|Output               |[C]=r                 |
;|OUT [n],A |------|Output               |[n]=A                 |
;|OUTD      |?*??1-|Output and Decrement |[C]=[HL],HL=HL-1,B=B-1|
;|OUTI      |?*??1-|Output and Increment |[C]=[HL],HL=HL+1,B=B-1|
;|POP xx    |------|Pop                  |xx=[SP]+              |
;|POP qq    |------|Pop                  |qq=[SP]+              |
;|PUSH xx   |------|Push                 |-[SP]=xx              |
;|PUSH qq   |------|Push                 |-[SP]=qq              |
;|RES b,m   |------|Reset bit            |m=m&{~2^b}            |
;|RET       |------|Return               |PC=[SP]+              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;|RETI      |------|Return from Interrupt|PC=[SP]+              |
;|RETN      |------|Return from NMI      |PC=[SP]+              |
;|RL m      |**0P0*|Rotate Left          |m={CY,m}<-            |
;|RLA       |--0-0*|Rotate Left Acc.     |A={CY,A}<-            |
;|RLC m     |**0P0*|Rotate Left Circular |m=m<-                 |
;|RLCA      |--0-0*|Rotate Left Circular |A=A<-                 |
;|RLD       |**0P0-|Rotate Left 4 bits   |{A,[HL]}={A,[HL]}<- ##|
;|RR m      |**0P0*|Rotate Right         |m=->{CY,m}            |
;|RRA       |--0-0*|Rotate Right Acc.    |A=->{CY,A}            |
;|RRC m     |**0P0*|Rotate Right Circular|m=->m                 |
;|RRCA      |--0-0*|Rotate Right Circular|A=->A                 |
;|RRD       |**0P0-|Rotate Right 4 bits  |{A,[HL]}=->{A,[HL]} ##|
;|RST p     |------|Restart              | (p=0H,8H,10H,...,38H)|
;|SBC A,s   |***V1*|Subtract with Carry  |A=A-s-CY              |
;|SBC HL,ss |**?V1*|Subtract with Carry  |HL=HL-ss-CY           |
;|SCF       |--0-01|Set Carry Flag       |CY=1                  |
;|SET b,m   |------|Set bit              |m=mv{2^b}             |
;|SLA m     |**0P0*|Shift Left Arithmetic|m=m*2                 |
;|SRA m     |**0P0*|Shift Right Arith.   |m=m/2                 |
;|SRL m     |**0P0*|Shift Right Logical  |m=->{0,m,CY}          |
;|SUB s     |***V1*|Subtract             |A=A-s                 |
;|XOR s     |**0P00|Logical Exclusive OR |A=Axs                 |
;|----------+------+--------------------------------------------|
;| F        |-*01? |Flag unaffected/affected/reset/set/unknown  |
;| S        |S     |Sign flag (Bit 7)                           |
;| Z        | Z    |Zero flag (Bit 6)                           |
;| HC       |  H   |Half Carry flag (Bit 4)                     |
;| P/V      |   P  |Parity/Overflow flag (Bit 2, V=overflow)    |
;| N        |    N |Add/Subtract flag (Bit 1)                   |
;| CY       |     C|Carry flag (Bit 0)                          |
;|-----------------+--------------------------------------------|
;| n               |Immediate addressing                        |
;| nn              |Immediate extended addressing               |
;| e               |Relative addressing (PC=PC+2+offset)        |
;| [nn]            |Extended addressing                         |
;| [xx+d]          |Indexed addressing                          |
;| r               |Register addressing                         |
;| [rr]            |Register indirect addressing                |
;|                 |Implied addressing                          |
;| b               |Bit addressing                              |
;| p               |Modified page zero addressing (see RST)     |
;|-----------------+--------------------------------------------|
;|DEFB n(,...)     |Define Byte(s)                              |
;|DEFB 'str'(,...) |Define Byte ASCII string(s)                 |
;|DEFS nn          |Define Storage Block                        |
;|DEFW nn(,...)    |Define Word(s)                              |
;|-----------------+--------------------------------------------|
;| A  B  C  D  E   |Registers (8-bit)                           |
;| AF  BC  DE  HL  |Register pairs (16-bit)                     |
;| F               |Flag register (8-bit)                       |
;| I               |Interrupt page address register (8-bit)     |
;| IX IY           |Index registers (16-bit)                    |
;| PC              |Program Counter register (16-bit)           |
;| R               |Memory Refresh register                     |
;| SP              |Stack Pointer register (16-bit)             |
;|-----------------+--------------------------------------------|
;| b               |One bit (0 to 7)                            |
;| cc              |Condition (C,M,NC,NZ,P,PE,PO,Z)             |
;| d               |One-byte expression (-128 to +127)          |
;| dst             |Destination s, ss, [BC], [DE], [HL], [nn]   |
;| e               |One-byte expression (-126 to +129)          |
;| m               |Any register r, [HL] or [xx+d]              |
;| n               |One-byte expression (0 to 255)              |
;| nn              |Two-byte expression (0 to 65535)            |
;| pp              |Register pair BC, DE, IX or SP              |
;| qq              |Register pair AF, BC, DE or HL              |
;| qq'             |Alternative register pair AF, BC, DE or HL  |
;| r               |Register A, B, C, D, E, H or L              |
;| rr              |Register pair BC, DE, IY or SP              |
;| s               |Any register r, value n, [HL] or [xx+d]     |
;| src             |Source s, ss, [BC], [DE], [HL], nn, [nn]    |
;| ss              |Register pair BC, DE, HL or SP              |
;| xx              |Index register IX or IY                     |
;|-----------------+--------------------------------------------|
;| +  -  *  /  ^   |Add/subtract/multiply/divide/exponent       |
;| &  ~  v  x      |Logical AND/NOT/inclusive OR/exclusive OR   |
;| <-  ->          |Rotate left/right                           |
;| [ ]             |Indirect addressing                         |
;| [ ]+  -[ ]      |Indirect addressing auto-increment/decrement|
;| { }             |Combination of operands                     |
;| #               |Also BC=BC-1,DE=DE-1                        |
;| ##              |Only lower 4 bits of accumulator A used     |
;----------------------------------------------------------------


.equ AVR_T = SREG_T
.equ AVR_H = SREG_H
.equ AVR_S = SREG_S
.equ AVR_V = SREG_V
.equ AVR_N = SREG_N
.equ AVR_Z = SREG_Z
.equ AVR_C = SREG_C

;------------------------------------------------;
; Load table value from flash indexed by source reg.
;
;	ldpmx	dstreg,tablebase,indexreg
;
; (6 words, 8 cycles)

.macro	ldpmx
	ldi	zh,high(@1*2)	; table must be page aligned
	mov	zl,@2		       
	lpm	@0,z	
.endm

.macro	do_z80_flags_HP
#if EM_Z80
	bmov	z_flags, ZFL_P, temp, AVR_V
	bmov	z_flags, ZFL_H, temp, AVR_H
#endif
.endm

.macro	do_z80_flags_set_N
#if EM_Z80
	ori	z_flags, (1<<ZFL_N)       ; Negation auf 1
#endif
.endm

.macro	do_z80_flags_set_HN
#if EM_Z80
	ori 	z_flags,(1<<ZFL_N)|(1<<ZFL_H)
#endif
.endm

.macro	do_z80_flags_clear_N
#if EM_Z80
	andi	z_flags,~(1<<ZFL_N)
#endif
.endm

.macro	do_z80_flags_op_rotate
	; must not change avr carry flag!
#if EM_Z80
	andi   z_flags, ~( (1<<ZFL_H) | (1<<ZFL_N) | (1<<ZFL_C) )
#else
	andi   z_flags, ~( (1<<ZFL_C) )
#endif
.endm

.macro	do_z80_flags_op_and
#if EM_Z80
	ori	z_flags,(1<<ZFL_H)
#else
	ori	z_flags,(1<<ZFL_H)
#endif
.endm

.macro	do_z80_flags_op_or
#if EM_Z80
#endif
.endm


;----------------------------------------------------------------

do_op_inv:
	rcall printstr
	.db "Invalid opcode @ PC=",0,0
	movw   temp,z_pcl
	rcall printhexw

haltinv:
	rjmp haltinv

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|OUT [n],A |------|Output               |[n]=A                 |
;
;
;Interface with peripherials goes here :)
do_op_outa: ; out (opl),a
.if PORT_DEBUG
	rcall printstr
	.db 13,"Port write: ",0
	mov temp,z_a
	rcall printhex
	rcall printstr
	.db " -> (",0
	mov temp,opl
	rcall printhex
	rcall printstr
	.db ")",13,0
.endif
	mov temp,z_a
	mov temp2,opl
	rcall portWrite
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|IN A,[n]  |------|Input                |A=[n]                 |
;
;
do_op_in:	; in a,(opl)
.if PORT_DEBUG
	rcall printstr
	.db 13,"Port read: (",0
	mov temp,opl
	rcall printhex
	rcall printstr
	.db ") -> ",0
.endif

	mov temp2,opl
	rcall portRead
	mov opl,temp

.if PORT_DEBUG
	rcall printhex
	rcall printstr
	.db 13,0
.endif
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|INC r     |***V0-|Increment            |r=r+1                 |
;|INC [HL]  |***V0-|Increment            |[HL]=[HL]+1           |
;|INC [xx+d]|***V0-|Increment            |[xx+d]=[xx+d]+1       |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|INC r     |**-P0-|Increment            |r=r+1                 |
;|INC [HL]  |**-P0-|Increment            |[HL]=[HL]+1           |
;
; 
do_op_inc:
	inc	opl
#if EM_Z80
	in	temp, sreg
#endif
	andi	z_flags,(1<<ZFL_H)|(1<<ZFL_C)	; preserve C-, and H-flag
	ldpmx	temp2, sz53p_tab, opl
	or	z_flags,temp2		;
	do_z80_flags_HP
	ret

do_op_inca:
	inc	z_a
#if EM_Z80
	in	temp, sreg
#endif
	andi	z_flags,(1<<ZFL_H)|(1<<ZFL_C)	; preserve C-, and H-flag
	ldpmx	temp2, sz53p_tab, z_a
	or	z_flags,temp2		;
	do_z80_flags_HP
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|DEC r     |***V1-|Decrement            |s=s-1                 |
;|INC [HL]  |***V0-|Increment            |[HL]=[HL]+1           |
;|INC [xx+d]|***V0-|Increment            |[xx+d]=[xx+d]+1       |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|DEC r     |**-P -|Increment            |r=r+1                 |
;|DEC [HL]  |**-P -|Increment            |[HL]=[HL]+1           |
;
;
do_op_dec:
	dec	opl
#if EM_Z80
	in    temp, sreg
#endif
	andi	z_flags,(1<<ZFL_H)|(1<<ZFL_C)	; preserve C-, and H-flag
	ldpmx	temp2, sz53p_tab, opl
	or	z_flags,temp2		;
	do_z80_flags_HP
	do_z80_flags_set_N
	ret

do_op_deca:
	dec	z_a
#if EM_Z80
	in    temp, sreg
#endif
	andi	z_flags,(1<<ZFL_H)|(1<<ZFL_C)	; preserve C-, and H-flag
	ldpmx	temp2, sz53p_tab, z_a
	or	z_flags,temp2		;
	do_z80_flags_HP
	do_z80_flags_set_N
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|INC xx    |------|Increment            |xx=xx+1               |
;|INC ss    |------|Increment            |ss=ss+1               |
;
; 
do_op_inc16:
	subi	opl,low(-1)
	sbci	oph,high(-1)
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|DEC xx    |------|Decrement            |xx=xx-1               |
;|DEC ss    |------|Decrement            |ss=ss-1               |
;
; 
do_op_dec16:
	subi   opl, 1
	sbci   oph, 0
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|RLCA      |--0-0*|Rotate Left Circular |A=A<-                 |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|RLCA      |---- *|Rotate Left Circular |A=A<-                 |
;
;
do_op_rlc:
	;Rotate Left Cyclical. All bits move 1 to the 
	;left, the msb becomes c and lsb.
	do_z80_flags_op_rotate
	lsl    opl
	brcc   do_op_rlc_noc
	ori    opl, 1
	ori    z_flags, (1<<ZFL_C)
do_op_rlc_noc:
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|RRCA      |--0-0*|Rotate Right Circular|A=->A                 |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|RRCA      |---- *|Rotate Right Circular|A=->A                 |
;
;
do_op_rrc: 
	;Rotate Right Cyclical. All bits move 1 to the 
	;right, the lsb becomes c and msb.
	do_z80_flags_op_rotate
	lsr    opl
	brcc   do_op_rrc_noc
	ori    opl, 0x80
	ori    z_flags, (1<<ZFL_C)
do_op_rrc_noc:
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|RRA       |--0-0*|Rotate Right Acc.    |A=->{CY,A}            |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|RRA       |---- *|Rotate Right Acc.    |A=->{CY,A}            |
;
; 
do_op_rr: 
	;Rotate Right. All bits move 1 to the right, the lsb 
	;becomes c, c becomes msb.
	clc				; get z80 carry to avr carry
	sbrc    z_flags,ZFL_C
	sec
	do_z80_flags_op_rotate		; (clear ZFL_C, doesn't change AVR_C)
	bmov	z_flags,ZFL_C, opl,0	; Bit 0 --> CY
	ror     opl
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|RLA       |--0-0*|Rotate Left Acc.     |A={CY,A}<-            |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|RLA       |---- *|Rotate Left Acc.     |A={CY,A}<-            |
;
; 
do_op_rl:
	;Rotate Left. All bits move 1 to the left, the msb 
	;becomes c, c becomes lsb.
	clc
	sbrc z_flags,ZFL_C
	 sec
	do_z80_flags_op_rotate		; (clear ZFL_C, doesn't change AVR_C)
	bmov	z_flags,ZFL_C, opl,7	; Bit 7 --> CY
	rol opl
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|ADD A,s   |***V0*|Add                  |A=A+s                 |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|ADD A,s   |***P *|Add                  |A=A+s                 |
;
;
do_op_adda:
	add z_a,opl
	in temp,sreg
	ldpmx	z_flags,sz53p_tab,z_a		;S,Z,P flag
	bmov	z_flags,ZFL_C, temp,AVR_C
	do_z80_flags_HP
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|ADC A,s   |***V0*|Add with Carry       |A=A+s+CY              |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|ADC A,s   |***P *|Add with Carry       |A=A+s+CY              |
;
;
do_op_adca:
	clc
	sbrc z_flags,ZFL_C
	 sec
	adc z_a,opl
	in temp,sreg
	ldpmx	z_flags,sz53p_tab,z_a		;S,Z,P
	bmov	z_flags,ZFL_C, temp,AVR_C
	do_z80_flags_HP
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|SUB s     |***V1*|Subtract             |A=A-s                 |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|SUB s     |***P *|Subtract             |A=A-s                 |

;
do_op_subfa:
	sub z_a,opl
	in temp,sreg
	ldpmx	z_flags,sz53p_tab,z_a		;S,Z,P
	bmov	z_flags,ZFL_C, temp,AVR_C
	do_z80_flags_HP
	do_z80_flags_set_N
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CP s      |***V1*|Compare              |A-s                   |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|CP s      |***P *|Compare              |A-s                   |

;
do_op_cpfa:
	mov temp,z_a
	sub temp,opl
	mov opl,temp
	in temp,sreg
	ldpmx	z_flags,sz53p_tab,opl		;S,Z,P
	bmov	z_flags,ZFL_C, temp,AVR_C
	do_z80_flags_HP
	do_z80_flags_set_N
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|SBC A,s   |***V1*|Subtract with Carry  |A=A-s-CY              |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|SBC A,s   |***P *|Subtract with Carry  |A=A-s-CY              |
;
;
do_op_sbcfa:
	clc
	sbrc z_flags,ZFL_C
	 sec
	sbc z_a,opl
	in temp,sreg
	ldpmx	z_flags,sz53p_tab,z_a		;S,Z,P
	bmov	z_flags,ZFL_C, temp,AVR_C
	do_z80_flags_HP
	do_z80_flags_set_N
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|AND s     |**1P00|Logical AND          |A=A&s                 |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|AND s     |**-P 0|Logical AND          |A=A&s                 |
;
; TODO H-Flag
do_op_anda:
	and z_a,opl				;
	ldpmx	z_flags,sz53p_tab,z_a		;S,Z,P,N,C
	do_z80_flags_op_and
	ret


;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|OR s      |**0P00|Logical inclusive OR |A=Avs                 |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|OR s      |**-P00|Logical inclusive OR |A=Avs                 |
;
; TODO: H-Flag
do_op_ora:
	or z_a,opl
	ldpmx	z_flags,sz53p_tab,z_a		;S,Z,H,P,N,C
	do_z80_flags_op_or
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|XOR s     |**0P00|Logical Exclusive OR |A=Axs                 |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|XOR s     |**-P 0|Logical Exclusive OR |A=Axs                 |
;
; TODO: H-Flag
do_op_xora:
	eor z_a,opl
	ldpmx	z_flags,sz53p_tab,z_a		;S,Z,H,P,N,C
	do_z80_flags_op_or
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|ADD HL,ss |--?-0*|Add                  |HL=HL+ss              |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|ADD HL,ss |---- *|Add                  |HL=HL+ss              |
;
;
do_op_addhl:
	lds	temp,z_l
	lds	temp2,z_h
	add opl,temp
	adc oph,temp2
	in temp,sreg
	bmov	z_flags,ZFL_H, temp,AVR_H
	bmov	z_flags,ZFL_C, temp,AVR_C
	do_z80_flags_clear_N
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|LD dst,src|------|Load                 |dst=src               |
;
;
do_op_sthl: ;store hl to mem loc in opl:h
	movw xl,opl
	lds temp,z_l
	mem_write
	adiw xl,1
	lds temp,z_h
	mem_write
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|LD dst,src|------|Load                 |dst=src               |
;
; 
do_op_rmem16:
	movw xl,opl
	mem_read_d opl
	adiw x,1
	mem_read_d oph
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|LD dst,src|------|Load                 |dst=src               |
;
;
do_op_rmem8:
	mem_read_ds opl, opl
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|DAA       |***P-*|Decimal Adjust Acc.  |                      |
;|----------|SZHP C|---------- 8080 ----------------------------|
;
; Not yet checked

; Description (http://www.z80.info/z80syntx.htm#DAA):
;  This instruction conditionally adjusts the accumulator for BCD addition
;  and subtraction operations. For addition (ADD, ADC, INC) or subtraction
;  (SUB, SBC, DEC, NEC), the following table indicates the operation performed:
;
; -------------------------------------------------------------------------------
; |          | C Flag  | HEX value in | H Flag | HEX value in | Number  | C flag|
; | Operation| Before  | upper digit  | Before | lower digit  | added   | After |
; |          | DAA     | (bit 7-4)    | DAA    | (bit 3-0)    | to byte | DAA   |
; |-----------------------------------------------------------------------------|
; |          |    0    |     0-9      |   0    |     0-9      |   00    |   0   |
; |   ADD    |    0    |     0-8      |   0    |     A-F      |   06    |   0   |
; |          |    0    |     0-9      |   1    |     0-3      |   06    |   0   |
; |   ADC    |    0    |     A-F      |   0    |     0-9      |   60    |   1   |
; |          |    0    |     9-F      |   0    |     A-F      |   66    |   1   |
; |   INC    |    0    |     A-F      |   1    |     0-3      |   66    |   1   |
; |          |    1    |     0-2      |   0    |     0-9      |   60    |   1   |
; |          |    1    |     0-2      |   0    |     A-F      |   66    |   1   |
; |          |    1    |     0-3      |   1    |     0-3      |   66    |   1   |
; |-----------------------------------------------------------------------------|
; |   SUB    |    0    |     0-9      |   0    |     0-9      |   00    |   0   |
; |   SBC    |    0    |     0-8      |   1    |     6-F      |   FA    |   0   |
; |   DEC    |    1    |     7-F      |   0    |     0-9      |   A0    |   1   |
; |   NEG    |    1    |     6-F      |   1    |     6-F      |   9A    |   1   |
; |-----------------------------------------------------------------------------|
;
; Flags:
;     C:   See instruction.
;     N:   Unaffected.
;     P/V: Set if Acc. is even parity after operation, reset otherwise.
;     H:   See instruction.
;     Z:   Set if Acc. is Zero after operation, reset otherwise.
;     S:   Set if most significant bit of Acc. is 1 after operation, reset otherwise.



#if 1
do_op_da:
	ldi 	oph,0				; what to add
	sbrc	z_flags,ZFL_H			; if H-Flag
	rjmp	op_da_06
	mov	temp,opl
	andi	temp,0x0f			; ... or lower digit > 9
	cpi	temp,0x0a
	brlo	op_da_06n
op_da_06:				
	ori	oph,0x06
op_da_06n:				
	sbrc	z_flags,(1<<ZFL_C)
	rjmp	op_da_60
	cpi	opl,0xa0
	brlo	op_da_60n
op_da_60:				
	ori	oph,0x60
op_da_60n:				
	cpi	opl,0x9a
	brlo	op_da_99n
	ori	z_flags,(1<<ZFL_C); set C
op_da_99n:
	sbrs	z_flags,ZFL_N			; if sub-op
	rjmp	op_da_add			; then
	sub	opl,oph
	rjmp	op_da_ex
op_da_add:					; else add-op
	cpi	opl,0x91
	brlo	op_da_60n2
	mov	temp,opl
	andi	temp,0x0f
	cpi	temp,0x0a
	brlo	op_da_60n2
	ori	oph,0x60
op_da_60n2:
	add	opl,oph
op_da_ex:
	in	temp,SREG	
	sbrc	temp,AVR_H
	ori	z_flags,(1<<ZFL_C)
	andi	z_flags,(1<<ZFL_N)|(1<<ZFL_C)	; preserve C,N
	ldpmx	temp2, sz53p_tab, opl		; get S,Z,P
	or	z_flags,temp2
	bmov	z_flags,ZFL_H, temp,AVR_H	; H  (?)
	ret
#else

do_op_da:
	sbrc	z_flags,ZFL_N			; if add-op	
	rjmp	do_op_da_sub			; then
	ldi		temp2,0			;
	mov		temp,opl		;
	andi	temp,0x0f			;
	cpi		temp,0x0a		;	if lower digit > 9
	brlo	do_op_da_h			;
	ori		temp2,0x06		;		add 6 to lower digit
do_op_da_h:					;
	sbrc	z_flags,ZFL_H			;   ... or H-Flag
	ori		temp2,0x06		;
	add		opl,temp2		;

	ldi		temp2,0			;
	mov		temp,opl		;
	andi	temp,0xf0			;
	cpi		temp,0xa0		;
	brlo	do_op_da_c			;
	ori		temp2,0x60		;
do_op_da_c:					; else sub-op
	sbrc	z_flags,ZFL_C			;
	ori		temp2,0x60		;
	andi	z_flags, ~( (1<<ZFL_S) | (1<<ZFL_Z) | (1<<ZFL_H) )
	add		opl,temp2		;
	in		temp,SREG		;
	bst		temp,AVR_Z		;Z-Flag
	bld		z_flags,ZFL_Z		;
	bst		temp,AVR_N		;S-Flag
	bst		z_flags,ZFL_S		;
	sbrc	temp2,5				;C-Flag, set if 0x06 added
	ori		z_flags,(1<<ZFL_C)	;
						;H-Flag?
	ret
	
do_op_da_sub:					;TODO:
	rcall do_op_inv
	ret
#endif

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|SCF       |--0-01|Set Carry Flag       |CY=1                  |
;|----------|SZHP C|---------- 8080 ----------------------------|
;
;
do_op_scf:
	andi	z_flags,~((1<<ZFL_H)|(1<<ZFL_N))
	ori 	z_flags,(1<<ZFL_C)
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CCF       |--?-0*|Complement Carry Flag|CY=~CY                |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|SCF       |---- 1|Set Carry Flag       |CY=1                  |
;
;TODO: H-Flag
do_op_ccf:
	do_z80_flags_clear_N
	ldi temp,(1<<ZFL_C)
	eor z_flags,temp
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CPL       |--1-1-|Complement           |A=~A                  |
;|----------|SZHP C|---------- 8080 ----------------------------|
;|CPL       |---- -|Complement           |A=~A                  |
;
;
do_op_cpl:
	com z_a
	do_z80_flags_set_HN
	ret


;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|PUSH xx   |------|Push                 |-[SP]=xx              |
;|PUSH qq   |------|Push                 |-[SP]=qq              |
;
;
do_op_push16:
	movw	xl,z_spl
	sbiw	x,1
	mem_write_s oph
	sbiw	x,1
	mem_write_s opl
	movw	z_spl,xl

.if STACK_DBG
	rcall printstr
	.db "Stack push ",0
	movw temp,opl
	rcall printhexw
	rcall printstr
	.db ", SP is now ",0
	movw temp,z_spl
	rcall printhexw
	rcall printstr
	.db ".",13,0
.endif

	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|POP xx    |------|Pop                  |xx=[SP]+              |
;|POP qq    |------|Pop                  |qq=[SP]+              |
;
;
do_op_pop16:
	movw	x,z_spl
	mem_read_d opl
	adiw	x,1
	mem_read_d oph
	adiw	x,1
	movw	z_spl,x

.if STACK_DBG
	rcall printstr
	.db "Stack pop: val ",0
	movw temp,opl
	rcall printhexw
	rcall printstr
	.db ", SP is now",0
	movw temp,z_spl
	rcall printhexw
	rcall printstr
	.db ".",13,0
.endif
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|EX [SP],HL|------|Exchange             |[SP]<->HL             |
;|EX DE,HL  |------|Exchange             |DE<->HL               |
;-----------------------------Z80--------------------------------
; 
do_op_exhl:
	lds temp,z_l
	lds temp2,z_h
	sts z_l,opl
	sts z_h,oph
	movw opl,temp
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;
; TODO: Implement IFF1, IFF2
do_op_di:
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;
; TODO: Implement IFF1, IFF2
do_op_ei:
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifnz:
	sbrs z_flags, ZFL_Z
	ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifz:
	sbrc z_flags, ZFL_Z
	ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifnc:
	sbrs z_flags, ZFL_C
	ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifc:
	sbrc z_flags, ZFL_C
	ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifpo:
	sbrs z_flags, ZFL_P
	ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifpe:
	sbrc z_flags, ZFL_P
	ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifp: ;sign positive, aka s=0
	sbrs z_flags, ZFL_S
	 ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

;----------------------------------------------------------------
;|Mnemonic  |SZHPNC|Description          |Notes                 |
;----------------------------------------------------------------
;|CALL cc,nn|------|Conditional Call     |If cc CALL            |
;|JP cc,nn  |------|Conditional Jump     |If cc JP              |
;|RET cc    |------|Conditional Return   |If cc RET             |
;
;
do_op_ifm: ;sign negative, aka s=1
	sbrc z_flags, ZFL_S
	 ret
	pop	temp				; nix tun
	pop temp				; direkt zuruech zu main	
	ret

	 
; ----------------------- Opcode decoding -------------------------

; Lookup table for Z80 opcodes. Translates the first byte of the instruction word into three
; operations: fetch, do something, store.
; The table is made of 256 words. These 16-bit words consist of 
; the fetch operation (bit 0-4), the processing operation (bit 10-16) and the store 
; operation (bit 5-9).
;.org (PC+255) & 0xff00
todo_table:
.dw 	low(do_nop)+low(do_nop)*256				.dw high(do_nop)+low(do_nop)*256			;00			;NOP		
.dw 	low(do_store_BC)+low(do_nop)*256		.dw high(do_nop)+low(do_fetch_DIR16)*256	;01 nn nn	;LD BC,nn	
.dw 	low(do_store_MBC)+low(do_nop)*256		.dw high(do_nop)+low(do_fetch_A)*256		;02			;LD (BC),A	
.dw 	low(do_store_BC)+low(do_op_INC16)*256 	.dw high(do_op_INC16)+low(do_fetch_BC )*256 ;03			;INC BC	
.dw 	low(do_store_B)+low(do_op_INC)*256 		.dw high(do_op_INC)+low(do_fetch_B)*256 	;04			;INC B	
.dw 	low(do_store_B)+low(do_op_DEC)*256 		.dw high(do_op_DEC)+low(do_fetch_B)*256 	;05			;DEC B	
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;06			;LD B,n	
.dw 	low(do_store_A)+low(do_op_RLC)*256 		.dw high(do_op_RLC)+low(do_fetch_A)*256 	;07			;RLCA	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256 		;08			;EX AF,AF'
.dw 	low(do_store_HL)+low(do_op_ADDHL)*256 	.dw high(do_op_ADDHL)+low(do_fetch_BC )*256 ;09			;ADD HL,BC	
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MBC)*256 		;0A       	;LD A,(BC)	
.dw 	low(do_store_BC)+low(do_op_DEC16)*256 	.dw high(do_op_DEC16)+low(do_fetch_BC )*256 ;0B       	;DEC BC	
.dw 	low(do_store_C)+low(do_op_INC)*256 		.dw high(do_op_INC)+low(do_fetch_C)*256 	;0C       	;INC C	
.dw 	low(do_store_C)+low(do_op_DEC)*256 		.dw high(do_op_DEC)+low(do_fetch_C)*256 	;0D       	;DEC C	
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;0E nn    	;LD C,n	
.dw 	low(do_store_A)+low(do_op_RRC)*256 		.dw high(do_op_RRC)+low(do_fetch_A)*256 	;0F       	;RRCA	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256			;10 oo    	;DJNZ o
.dw 	low(do_store_DE)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR16)*256 	;11 nn nn	;LD DE,nn
.dw 	low(do_store_MDE)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;12			;LD (DE),A	
.dw 	low(do_store_DE)+low(do_op_INC16)*256 	.dw high(do_op_INC16)+low(do_fetch_DE)*256 	;13			;INC DE	
.dw 	low(do_store_D)+low(do_op_INC)*256 		.dw high(do_op_INC)+low(do_fetch_D)*256 	;14			;INC D	
.dw 	low(do_store_D)+low(do_op_DEC)*256 		.dw high(do_op_DEC)+low(do_fetch_D)*256 	;15			;DEC D	
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;16 nn		;LD D,n	
.dw 	low(do_store_A)+low(do_op_RL)*256 		.dw high(do_op_RL)+low(do_fetch_A)*256 		;17			;RLA	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_NOP)*256 		;18 oo		;JR o
.dw 	low(do_store_HL)+low(do_op_ADDHL)*256 	.dw high(do_op_ADDHL)+low(do_fetch_DE)*256 	;19			;ADD HL,DE	
.dw 	low(do_store_A)+low(do_nop)*256			.dw high(do_nop)+low(do_fetch_MDE)*256 		;1A			;LD A,(DE)	
.dw 	low(do_store_DE)+low(do_op_DEC16)*256 	.dw high(do_op_DEC16)+low(do_fetch_DE)*256 	;1B			;DEC DE	
.dw 	low(do_store_E)+low(do_op_INC)*256 		.dw high(do_op_INC)+low(do_fetch_E)*256 	;1C			;INC E	
.dw 	low(do_store_E)+low(do_op_DEC)*256 		.dw high(do_op_DEC)+low(do_fetch_E)*256 	;1D			;DEC E	
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;1E nn		;LD E,n	
.dw 	low(do_store_A)+low(do_op_RR)*256 		.dw high(do_op_RR)+low(do_fetch_A)*256 		;1F			;RRA	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop )*256		;20 oo		;JR NZ,o
.dw 	low(do_store_HL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR16)*256 	;21 nn nn	;LD HL,nn	
.dw 	low(do_nop)+low(do_op_STHL)*256 		.dw high(do_op_STHL)+low(do_fetch_DIR16)*256;22 nn nn	;LD (nn),HL	
.dw 	low(do_store_HL)+low(do_op_INC16)*256 	.dw high(do_op_INC16)+low(do_fetch_HL)*256	;23			;INC HL	
.dw 	low(do_store_H)+low(do_op_INC)*256 		.dw high(do_op_INC)+low(do_fetch_H)*256		;24			;INC H	
.dw 	low(do_store_H)+low(do_op_DEC)*256 		.dw high(do_op_DEC)+low(do_fetch_H)*256 	;25			;DEC H	
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;26 nn		;LD H,n	
.dw 	low(do_store_A)+low(do_op_DA)*256 		.dw high(do_op_DA)+low(do_fetch_A)*256 		;27			;DAA	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256 		;28 oo		;JR Z,o
.dw 	low(do_store_HL)+low(do_op_ADDHL)*256 	.dw high(do_op_ADDHL)+low(do_fetch_HL)*256 	;29			;ADD HL,HL	
.dw 	low(do_store_HL)+low(do_op_RMEM16)*256	.dw high(do_op_RMEM16)+low(do_fetch_DIR16)*256;	2A nn nn;LD HL,(nn)	
.dw 	low(do_store_HL)+low(do_op_DEC16)*256 	.dw high(do_op_DEC16)+low(do_fetch_HL)*256	;2B			;DEC HL	
.dw 	low(do_store_L)+low(do_op_INC)*256 		.dw high(do_op_INC)+low(do_fetch_L)*256 	;2C			;INC L	
.dw 	low(do_store_L)+low(do_op_DEC)*256 		.dw high(do_op_DEC)+low(do_fetch_L)*256 	;2D			;DEC L	
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;2E nn		;LD L,n	
.dw 	low(do_nop)+low(do_op_CPL)*256 			.dw high(do_op_CPL)+low(do_nop)*256 		;2F			;CPL	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256			;30 oo		;JR NC,o
.dw 	low(do_store_SP)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR16)*256 	;31 nn nn	;LD SP,nn	
.dw 	low(do_store_AM)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR16)*256 	;32 nn nn	;LD (nn),A	
.dw 	low(do_store_SP)+low(do_op_INC16)*256 	.dw high(do_op_INC16)+low(do_fetch_SP)*256 	;33			;INC SP	
.dw 	low(do_store_MHL)+low(do_op_INC)*256 	.dw high(do_op_INC)+low(do_fetch_MHL)*256 	;34			;INC (HL)	
.dw 	low(do_store_MHL)+low(do_op_DEC)*256 	.dw high(do_op_DEC)+low(do_fetch_MHL)*256 	;35			;DEC (HL)	
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;36 nn		;LD (HL),n	
.dw 	low(do_nop)+low(do_op_SCF)*256 			.dw high(do_op_SCF)+low(do_nop)*256 		;37			;SCF	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256 		;38 oo		;JR C,o
.dw 	low(do_store_HL)+low(do_op_ADDHL)*256 	.dw high(do_op_ADDHL)+low(do_fetch_SP)*256 	;39			;ADD HL,SP	
.dw 	low(do_store_A)+low(do_op_RMEM8)*256 	.dw high(do_op_RMEM8)+low(do_fetch_DIR16)*256;3A nn nn	;LD A,(nn)	
.dw 	low(do_store_SP)+low(do_op_DEC16)*256 	.dw high(do_op_DEC16)+low(do_fetch_SP)*256 	;3B			;DEC SP	
.dw 	low(do_nop)+low(do_op_INCA)*256 		.dw high(do_op_INCA)+low(do_nop)*256 		;3C			;INC A	
.dw 	low(do_nop)+low(do_op_DECA)*256 		.dw high(do_op_DECA)+low(do_nop)*256 		;3D			;DEC A	
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR8)*256 	;3E nn		;LD A,n	
.dw 	low(do_nop)+low(do_op_CCF)*256 			.dw high(do_op_CCF)+low(do_nop)*256 		;3F			;CCF (Complement Carry Flag, gvd)	;	
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;40			;LD B,B
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;41			;LD B,C
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;42			;LD B,D
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;43			;LD B,E
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;44			;LD B,H
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;45			;LD B,L
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MHL)*256 		;46			;LD B,(HL)
.dw 	low(do_store_B)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;47			;LD B,A
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;48			;LD C,B
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;49			;LD C,C
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;4A			;LD C,D
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;4B			;LD C,E
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;4C			;LD C,H
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;4D			;LD C,L
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MHL)*256 		;4E			;LD C,(HL)
.dw 	low(do_store_C)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;4F			;LD C,A
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;50			;LD D,B
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;51			;LD D,C
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;52			;LD D,D
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;53			;LD D,E
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;54			;LD D,H
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;55			;LD D,L
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MHL)*256 		;56			;LD D,(HL)
.dw 	low(do_store_D)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;57			;LD D,A
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;58			;LD E,B
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;59			;LD E,C
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;5A			;LD E,D
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;5B			;LD E,E
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;5C			;LD E,H
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;5D			;LD E,L
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MHL)*256 		;5E			;LD E,(HL)
.dw 	low(do_store_E)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;5F			;LD E,A
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;60			;LD H,B
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;61			;LD H,C
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;62			;LD H,D
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;63			;LD H,E
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;64			;LD H,H
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;65			;LD H,L
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MHL)*256 		;66			;LD H,(HL)
.dw 	low(do_store_H)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;67			;LD H,A
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;68			;LD L,B
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;69			;LD L,C
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;6A			;LD L,D
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;6B			;LD L,E
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;6C			;LD L,H
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;6D			;LD L,L
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MHL)*256 		;6E			;LD L,(HL)
.dw 	low(do_store_L)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;6F			;LD L,A
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;70			;LD (HL),B
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;71			;LD (HL),C
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;72			;LD (HL),D
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;73			;LD (HL),E
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;74			;LD (HL),H
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;75			;LD (HL),L
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256			;76			;HALT
.dw 	low(do_store_MHL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;77			;LD (HL),A
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_B)*256 		;78			;LD A,B
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_C)*256 		;79			;LD A,C
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_D)*256 		;7A			;LD A,D
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_E)*256 		;7B			;LD A,E
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_H)*256 		;7C			;LD A,H
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_L)*256 		;7D			;LD A,L
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_MHL)*256 		;7E			;LD A,(HL)
.dw 	low(do_store_A)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_A)*256 		;7F			;LD A,A
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_B)*256 	;80			;ADD A,B
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_C)*256 	;81			;ADD A,C
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_D)*256 	;82			;ADD A,D
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_E)*256 	;83			;ADD A,E
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_H)*256 	;84			;ADD A,H
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_L)*256 	;85			;ADD A,L
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_MHL)*256 	;86			;ADD A,(HL)
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_A)*256 	;87			;ADD A,A
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_B)*256 	;88			;ADC A,B
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_C)*256 	;89			;ADC A,C
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_D)*256 	;8A			;ADC A,D
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_E)*256 	;8B			;ADC A,E
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_H)*256 	;8C			;ADC A,H
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_L)*256 	;8D			;ADC A,L
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_MHL)*256 	;8E			;ADC A,(HL)
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_A)*256 	;8F			;ADC A,A
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_B)*256 	;90			;SUB A,B
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_C)*256 	;91			;SUB A,C
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_D)*256 	;92			;SUB A,D
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_E)*256 	;93			;SUB A,E
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_H)*256 	;94			;SUB A,H
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_L)*256 	;95			;SUB A,L
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_MHL)*256 ;96			;SUB A,(HL)
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_A)*256 	;97			;SUB A,A
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_B)*256 	;98			;SBC A,B
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_C)*256 	;99			;SBC A,C
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_D)*256 	;9A			;SBC A,D
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_E)*256 	;9B			;SBC A,E
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_H)*256 	;9C			;SBC A,H
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_L)*256 	;9D			;SBC A,L
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_MHL)*256 ;9E			;SBC A,(HL)
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_A)*256 	;9F			;SBC A,A
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_B)*256 	;A0			;AND A,B
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_C)*256 	;A1			;AND A,C
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_D)*256 	;A2			;AND A,D
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_E)*256 	;A3			;AND A,E
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_H)*256 	;A4			;AND A,H
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_L)*256 	;A5			;AND A,L
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_MHL)*256 	;A6			;AND A,(HL)
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_A)*256 	;A7			;AND A,A
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_B)*256 	;A8			;XOR A,B
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_C)*256 	;A9			;XOR A,C
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_D)*256 	;AA			;XOR A,D
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_E)*256 	;AB			;XOR A,E
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_H)*256 	;AC			;XOR A,H
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_L)*256 	;AD			;XOR A,L
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_MHL)*256 	;AE			;XOR A,(HL)
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_A)*256 	;AF			;XOR A,A
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_B)*256 	;B0			;OR A,B
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_C)*256 	;B1			;OR A,C
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_D)*256 	;B2			;OR A,D
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_E)*256 	;B3			;OR A,E
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_H)*256 	;B4			;OR A,H
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_L)*256 	;B5			;OR A,L
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_MHL)*256 	;B6			;OR A,(HL)
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_A)*256 	;B7			;OR A,A
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_B)*256 	;B8			;CP A,B
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_C)*256 	;B9			;CP A,C
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_D)*256 	;BA			;CP A,D
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_E)*256 	;BB			;CP A,E
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_H)*256 	;BC			;CP A,H
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_L)*256 	;BD			;CP A,L
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_MHL)*256 	;BE			;CP A,(HL)
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_A)*256 	;BF 		;CP A,A
.dw 	low(do_store_RET)+low(do_op_IFNZ)*256 	.dw high(do_op_IFNZ)+low(do_nop)*256 		;C0			;RET NZ	
.dw 	low(do_store_BC)+low(do_op_POP16)*256 	.dw high(do_op_POP16)+low(do_nop)*256 		;C1			;POP BC
.dw 	low(do_store_PC)+low(do_op_IFNZ)*256 	.dw high(do_op_IFNZ)+low(do_fetch_DIR16)*256;C2 nn nn	;JP NZ,nn
.dw 	low(do_store_PC)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR16)*256 	;C3 nn nn	;JP nn
.dw 	low(do_store_CALL)+low(do_op_IFNZ)*256 	.dw high(do_op_IFNZ)+low(do_fetch_DIR16)*256;C4 nn nn	;CALL NZ,nn
.dw 	low(do_nop)+low(do_op_PUSH16)*256 		.dw high(do_op_PUSH16)+low(do_fetch_BC)*256 ;C5			;PUSH BC
.dw 	low(do_nop)+low(do_op_ADDA)*256 		.dw high(do_op_ADDA)+low(do_fetch_DIR8)*256 ;C6 nn		;ADD A,n
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256 		;C7			;RST 0
.dw 	low(do_store_RET)+low(do_op_IFZ)*256 	.dw high(do_op_IFZ)+low(do_nop)*256 		;C8			;RET Z
.dw 	low(do_store_RET)+low(do_nop)*256 		.dw high(do_nop)+low(do_nop)*256 			;C9			;RET
.dw 	low(do_store_PC)+low(do_op_IFZ)*256 	.dw high(do_op_IFZ)+low(do_fetch_DIR16)*256 ;CA nn nn	;JP Z,nn
.dw 	low(do_nop)+low(do_op_INV)*256			.dw high(do_op_INV)+low(do_nop)*256 		;CB 		;(Z80 specific)
.dw 	low(do_store_CALL)+low(do_op_IFZ)*256 	.dw high(do_op_IFZ)+low(do_fetch_DIR16)*256 ;CC nn nn	;CALL Z,nn
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_DIR16)*256 	;CD nn nn	;CALL nn
.dw 	low(do_nop)+low(do_op_ADCA)*256 		.dw high(do_op_ADCA)+low(do_fetch_DIR8)*256 ;CE nn		;ADC A,n
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256	 	;CF			;RST 8H
.dw 	low(do_store_RET)+low(do_op_IFNC)*256 	.dw high(do_op_IFNC)+low(do_nop)*256 		;D0			;RET NC	
.dw 	low(do_store_DE)+low(do_op_POP16)*256 	.dw high(do_op_POP16)+low(do_nop)*256 		;D1			;POP DE	
.dw 	low(do_store_PC)+low(do_op_IFNC)*256 	.dw high(do_op_IFNC)+low(do_fetch_DIR16)*256;D2 nn nn	;JP NC,nn	
.dw 	low(do_nop)+low(do_op_OUTA)*256 		.dw high(do_op_OUTA)+low(do_fetch_DIR8)*256 ;D3 nn		;OUT (n),A	
.dw 	low(do_store_CALL)+low(do_op_IFNC)*256 	.dw high(do_op_IFNC)+low(do_fetch_DIR16)*256;D4 nn nn	;CALL NC,nn	
.dw 	low(do_nop)+low(do_op_PUSH16)*256 		.dw high(do_op_PUSH16)+low(do_fetch_DE)*256 ;D5			;PUSH DE	
.dw 	low(do_nop)+low(do_op_SUBFA)*256 		.dw high(do_op_SUBFA)+low(do_fetch_DIR8)*256;D6 nn		;SUB n	
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256	 	;D7			;RST 10H	
.dw 	low(do_store_RET)+low(do_op_IFC)*256 	.dw high(do_op_IFC)+low(do_nop)*256 		;D8			;RET C	
.dw 	low(do_nop)+low(do_nop)*256 			.dw high(do_nop)+low(do_nop)*256 			;D9			;EXX
.dw 	low(do_store_PC)+low(do_op_IFC)*256 	.dw high(do_op_IFC)+low(do_fetch_DIR16)*256 ;DA nn nn	;JP C,nn	
.dw 	low(do_store_A)+low(do_op_IN )*256 		.dw high(do_op_IN )+low(do_fetch_DIR8)*256 	;DB nn		;IN A,(n)	
.dw 	low(do_store_CALL)+low(do_op_IFC)*256 	.dw high(do_op_IFC)+low(do_fetch_DIR16)*256 ;DC nn nn	;CALL C,nn	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256 		;DD 		;(Z80 specific)
.dw 	low(do_nop)+low(do_op_SBCFA)*256 		.dw high(do_op_SBCFA)+low(do_fetch_DIR8)*256;DE nn		;SBC A,n	
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256	 	;DF			;RST 18H	
.dw 	low(do_store_RET)+low(do_op_IFPO)*256 	.dw high(do_op_IFPO)+low(do_nop)*256 		;E0			;RET PO	
.dw 	low(do_store_HL)+low(do_op_POP16)*256 	.dw high(do_op_POP16)+low(do_nop)*256 		;E1			;POP HL	
.dw 	low(do_store_PC)+low(do_op_IFPO)*256 	.dw high(do_op_IFPO)+low(do_fetch_DIR16)*256;E2 nn nn	;JP PO,nn	
.dw 	low(do_store_MSP)+low(do_op_EXHL)*256 	.dw high(do_op_EXHL)+low(do_fetch_MSP)*256	;E3			;EX (SP),HL	
.dw 	low(do_store_CALL)+low(do_op_IFPO)*256 	.dw high(do_op_IFPO)+low(do_fetch_DIR16)*256;E4 nn nn	;CALL PO,nn	
.dw 	low(do_nop)+low(do_op_PUSH16)*256 		.dw high(do_op_PUSH16)+low(do_fetch_HL)*256 ;E5			;PUSH HL	
.dw 	low(do_nop)+low(do_op_ANDA)*256 		.dw high(do_op_ANDA)+low(do_fetch_DIR8)*256 ;E6 nn		;AND n	
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256	 	;E7			;RST 20H	
.dw 	low(do_store_RET)+low(do_op_IFPE)*256 	.dw high(do_op_IFPE)+low(do_nop)*256 		;E8			;RET PE	
.dw 	low(do_store_PC)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_HL)*256 		;E9			;JP HL	
.dw 	low(do_store_PC)+low(do_op_IFPE)*256 	.dw high(do_op_IFPE)+low(do_fetch_DIR16)*256;EA nn nn	;JP PE,nn	
.dw 	low(do_store_DE)+low(do_op_EXHL)*256 	.dw high(do_op_EXHL)+low(do_fetch_DE)*256 	;EB			;EX DE,HL	
.dw 	low(do_store_CALL)+low(do_op_IFPE)*256 	.dw high(do_op_IFPE)+low(do_fetch_DIR16)*256;EC nn nn	;CALL PE,nn	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256 		;ED			;(Z80 specific)
.dw 	low(do_nop)+low(do_op_XORA)*256 		.dw high(do_op_XORA)+low(do_fetch_DIR8)*256 ;EE nn		;XOR n	
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256	 	;EF			;RST 28H	
.dw 	low(do_store_RET)+low(do_op_IFP)*256 	.dw high(do_op_IFP)+low(do_nop)*256 		;F0			;RET P	
.dw 	low(do_store_AF)+low(do_op_POP16)*256 	.dw high(do_op_POP16)+low(do_nop)*256 		;F1			;POP AF	
.dw 	low(do_store_PC)+low(do_op_IFP)*256 	.dw high(do_op_IFP)+low(do_fetch_DIR16)*256 ;F2 nn nn	;JP P,nn	
.dw 	low(do_nop)+low(do_op_DI)*256 			.dw high(do_op_DI)+low(do_nop)*256 			;F3			;DI	
.dw 	low(do_store_CALL)+low(do_op_IFP)*256 	.dw high(do_op_IFP)+low(do_fetch_DIR16)*256 ;F4 nn nn	;CALL P,nn	
.dw 	low(do_nop)+low(do_op_PUSH16)*256 		.dw high(do_op_PUSH16)+low(do_fetch_AF)*256 ;F5			;PUSH AF	
.dw 	low(do_nop)+low(do_op_ORA)*256 			.dw high(do_op_ORA)+low(do_fetch_DIR8)*256 	;F6 nn		;OR n	
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256	 	;F7			;RST 30H	
.dw 	low(do_store_RET)+low(do_op_IFM)*256 	.dw high(do_op_IFM)+low(do_nop)*256 		;F8			;RET M	
.dw 	low(do_store_SP)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_HL)*256 		;F9			;LD SP,HL	
.dw 	low(do_store_PC)+low(do_op_IFM)*256 	.dw high(do_op_IFM)+low(do_fetch_DIR16)*256 ;FA nn nn	;JP M,nn	
.dw 	low(do_nop)+low(do_op_EI )*256 			.dw high(do_op_EI )+low(do_nop)*256 		;FB			;EI	
.dw 	low(do_store_CALL)+low(do_op_IFM)*256 	.dw high(do_op_IFM)+low(do_fetch_DIR16)*256 ;FC nn nn	;CALL M,nn	
.dw 	low(do_nop)+low(do_op_INV)*256 			.dw high(do_op_INV)+low(do_nop)*256 		;FD 		;(Z80 specific)
.dw 	low(do_nop)+low(do_op_CPFA)*256 		.dw high(do_op_CPFA)+low(do_fetch_DIR8)*256 ;FE nn		;CP n	
.dw 	low(do_store_CALL)+low(do_nop)*256 		.dw high(do_nop)+low(do_fetch_RST)*256 		;FF			;RST 38H	
;----------------------------------------------------------------
; Lookup table, stolen from z80ex, Z80 emulation library.
; http://z80ex.sourceforge.net/

; The S, Z, 5 and 3 bits and the parity of the lookup value 

	.org (PC+255) & 0xff00
sz53p_tab:
	.db 0x44,0x00,0x00,0x04,0x00,0x04,0x04,0x00
	.db 0x08,0x0c,0x0c,0x08,0x0c,0x08,0x08,0x0c
	.db 0x00,0x04,0x04,0x00,0x04,0x00,0x00,0x04
	.db 0x0c,0x08,0x08,0x0c,0x08,0x0c,0x0c,0x08
	.db 0x20,0x24,0x24,0x20,0x24,0x20,0x20,0x24
	.db 0x2c,0x28,0x28,0x2c,0x28,0x2c,0x2c,0x28
	.db 0x24,0x20,0x20,0x24,0x20,0x24,0x24,0x20
	.db 0x28,0x2c,0x2c,0x28,0x2c,0x28,0x28,0x2c
	.db 0x00,0x04,0x04,0x00,0x04,0x00,0x00,0x04
	.db 0x0c,0x08,0x08,0x0c,0x08,0x0c,0x0c,0x08
	.db 0x04,0x00,0x00,0x04,0x00,0x04,0x04,0x00
	.db 0x08,0x0c,0x0c,0x08,0x0c,0x08,0x08,0x0c
	.db 0x24,0x20,0x20,0x24,0x20,0x24,0x24,0x20
	.db 0x28,0x2c,0x2c,0x28,0x2c,0x28,0x28,0x2c
	.db 0x20,0x24,0x24,0x20,0x24,0x20,0x20,0x24
	.db 0x2c,0x28,0x28,0x2c,0x28,0x2c,0x2c,0x28
	.db 0x80,0x84,0x84,0x80,0x84,0x80,0x80,0x84
	.db 0x8c,0x88,0x88,0x8c,0x88,0x8c,0x8c,0x88
	.db 0x84,0x80,0x80,0x84,0x80,0x84,0x84,0x80
	.db 0x88,0x8c,0x8c,0x88,0x8c,0x88,0x88,0x8c
	.db 0xa4,0xa0,0xa0,0xa4,0xa0,0xa4,0xa4,0xa0
	.db 0xa8,0xac,0xac,0xa8,0xac,0xa8,0xa8,0xac
	.db 0xa0,0xa4,0xa4,0xa0,0xa4,0xa0,0xa0,0xa4
	.db 0xac,0xa8,0xa8,0xac,0xa8,0xac,0xac,0xa8
	.db 0x84,0x80,0x80,0x84,0x80,0x84,0x84,0x80
	.db 0x88,0x8c,0x8c,0x88,0x8c,0x88,0x88,0x8c
	.db 0x80,0x84,0x84,0x80,0x84,0x80,0x80,0x84
	.db 0x8c,0x88,0x88,0x8c,0x88,0x8c,0x8c,0x88
	.db 0xa0,0xa4,0xa4,0xa0,0xa4,0xa0,0xa0,0xa4
	.db 0xac,0xa8,0xa8,0xac,0xa8,0xac,0xac,0xa8
	.db 0xa4,0xa0,0xa0,0xa4,0xa0,0xa4,0xa4,0xa0
	.db 0xa8,0xac,0xac,0xa8,0xac,0xa8,0xa8,0xac
	
; vim:set ts=8 noet nowrap

