;    Z80 emulator with CP/M support. 
;    
;    Copyright (C) 2010 Sprite_tm
;
;    This file is part of avrcpm.
;
;    avrcpm is free software: you can redistribute it and/or modify it
;    under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    avrcpm is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with avrcpm.  If not, see <http://www.gnu.org/licenses/>.
;
;    $Id$
;

.nolist
#if defined atmega8
	.include "m8def.inc"
#elif defined atmega168
	.include "m168def.inc"
#elif defined atmega328P
	.include "m328Pdef.inc"
#else                               /* default */
	.include "m88def.inc"
#endif
	.include "config.inc"
	
	.include "macros.inc"
.list

	.cseg
	.org 0
	rjmp start		; reset vector
	.org OC2Aaddr
	rjmp refrint		; tim2cmpa
	.org OC1Aaddr  		; Timer/Counter1 Compare Match A
    	rjmp sysclockint	; 1ms system timer
    	
	.org INT_VECTORS_SIZE

	.include "hw-uart.asm"
	.include "dram-4bit.asm"
	.include "remainders.asm"
	.include "z80int.asm"

	.dseg
ramtop:	.byte	0
	
	.cseg

; vim:set ts=8 noet nowrap

